#!/usr/bin/env bash

set -euf -o pipefail

readonly fedora_packages=(
  'R'
  'ShellCheck'
  'VirtualBox'
  'ansible'
  'atool'
  'bash'
  'bat'
  'bc'
  'ccrypt'
  'chromium'
  'chromium-libs'
  'chromium-libs-media-freeworld'
  'clamav'
  'cloc'
  'cmake'
  'colordiff'
  'curl'
  'dconf-editor'
  'deadbeef'
  'discord'
  'docker'
  'dropbox'
  'emacs'
  'fabric'
  'fd-find'
  'firefox'
  'fzf'
  'gcc'
  'gdb'
  'gimp'
  'git'
  'git-extras'
  'git-secret'
  'gitflow'
  'gnome-tweak-tool'
  'gnupg'
  'graphviz'
  'grep'
  'gzip'
  'htop'
  'httpie'
  'ioping'
  'jq'
  'keepass'
  'kernel-devel'
  'kernel-headers'
  'lnav'
  'lapack'
  'less'
  'libcgroup-tools'
  'libpng-devel'
  'libtiff-devel'
  'libyaml-devel'
  'lshw'
  'lynis'
  'make'
  'makeself'
  'mc'
  'md5deep'
  'megasync'
  'mosh'
  'nano'
  'nautilus-dropbox'
  'okular'
  'openblas'
  'openssh'
  'openssh-server'
  'p7zip'
  'pandoc'
  'patch'
  'pipenv'
  'pkg-config'
  'postgresql'
  'postgresql-server'
  'pypy'
  'pypy3'
  'python3'
  'python3-devel'
  'rclone'
  'rsync'
  'sqlite'
  'supervisor'
  'sysstat'
  'telegram-desktop'
  'texlive'
  'texstudio'
  'the_silver_searcher'
  'thunderbird'
  'tig'
  'tmux'
  'tmuxinator'
  'transmission'
  'tree'
  'unrar'
  'unzip'
  'vagrant'
  'vlc'
  'vmtouch'
  'wget'
  'xclip'
  'xz'
)

readonly macos_cask_packages=(
  'copyq'
  'deadbeef-devel'
  'discord'
  'docker'
  'dropbox'
  'emacs'
  'firefox'
  'gimp'
  'google-chrome'
  'gpg-suite'
  'iterm2'
  'keepassx'
  'mactex-no-gui'
  'megasync'
  'ngrok'
  'notion'
  'protonvpn'
  'skype'
  'slack'
  'teamviewer'
  'telegram'
  'texstudio'
  'thunderbird'
  'transmission'
  'vagrant'
  'vagrant-manager'
  # 'virtualbox'
  # 'virtualbox-extension-pack'
  'vlc'
  'zoomus'
)

readonly macos_packages=(
  'ansible'
  'atool'
  'bash'
  'bat'
  'bc'
  'binutils'
  'ccrypt'
  'clamav'
  'cloc'
  'cmake'
  'colordiff'
  'coreutils'
  'curl'
  'diffutils'
  'fabric'
  'fd'
  'file-formula'
  'findutils'
  'fzf'
  'gawk'
  'gcc'
  'gdb'
  'git'
  'git-extras'
  'git-flow'
  'git-secret'
  'gnu-sed'
  'gnu-tar'
  'gnu-which'
  'gpatch'
  'graphviz'
  'grep'
  'gzip'
  'hashdeep'
  'htop'
  'httpie'
  'ioping'
  'jq'
  'lapack'
  'less'
  'libressl'
  'lnav'
  'lynis'
  'make'
  'makeself'
  'mc'
  'mosh'
  'nano'
  'nmap'
  'openblas'
  'openssh'
  'p7zip'
  'pandoc'
  'pipenv'
  'pkg-config'
  'postgresql'
  'pypy'
  'pypy3'
  'python3'
  'r'
  'rclone'
  'rsync'
  'shellcheck'
  'sqlite'
  'supervisor'
  'the_silver_searcher'
  'tig'
  'tmux'
  'tmuxinator'
  'tree'
  'unrar'
  'unzip'
  'vmtouch'
  'watch'
  'wdiff'
  'wget'
  'xz'
)

readonly python_packages=(
  'auditwheel'
  'biokit'
  'black'
  'cython'
  'flake8'
  'imbalanced-learn'
  'jupyter'
  'jupyterlab'
  'k3d'
  'keras'
  'matplotlib'
  'nltk'
  'numba'
  'numpy'
  'opencv-python'
  'pandas'
  'pillow'
  'psutil'
  'pylint'
  'scikit-image'
  'scikit-learn'
  'scipy'
  'seaborn'
  'sshuttle'
  'statsmodels'
  'sympy'
  'tensorflow'
  'torch'
  'torchvision'
  'tqdm'
  'virtualenv'
  'virtualenvwrapper'
  'xgboost'
  'youtube-dl'
)

_message_error() {
  printf "[ \\e[31;1mERROR\\e[0m ]: %s\\n" "$1"
}

_message_info() {
  printf "[ \\e[36;1mINFO\\e[0m ]: %s\\n" "$1"
}

_message_success() {
  printf "[ \\e[32;1mOK\\e[0m ]: %s\\n" "$1"
}

main() {
  echo
}

main "$@"
